/*
    TO DO
        Add turn of escape to struct GstPatternStr
*/
#ifndef GEISTERDATABASE_H

#define GEISTERDATABASE_H 1

#include "geisterlib.h"
#include <stdbool.h>

// attribute of ghost
#define GstPly0b 0 // your blue ghost
#define GstPly0r 1 // your red ghost
#define GstPly0g 2 // your ghost (don't defined color)
#define GstPly0n 3 // your ghost or null
#define GstPly1b 4 // opponent's blue ghost
#define GstPly1r 5 // opponent's red ghost
#define GstPly1g 6 // opponent's ghost (don't defined color) 
#define GstPly1n 7 // opponent's ghost or null
#define GstRegardless 8

#define NumBasedPattern 8
#define NumPattern NumBasedPattern*2
#define NumMovesOfSearch 6

// Board Width and Height
#define GstBdW 6
#define GstBdH 6

struct GstPatternStr{
    int board[GstBdW][GstBdH];
    //tell moving ghost by using x, y and dir.
    int x;
    int y;
    int dir;
    int turn;
    int restRed;
};

int GstPatternMatching(struct GstGameStr *s, struct GstActionStr *a,struct GstPatternStr *b);
int GstBlockEscape(struct GstGameStr *s, struct GstActionStr *a, struct GstPatternStr *b);
int GstPatternSet(struct GstPatternStr *b);
int GstColorInference(struct GstGameStr *s,int first,int *color_inf,float *red_th,float *blue_th,float *confidence, struct GstActionStr *a_opp,int cap);
int GstEvaluation(struct GstGameStr *s,struct GstPatternStr *b);
int GstAlphaBeta(struct GstGameStr *s,bool my_turn,int depth,int alpha,int beta,double *passT,struct GstPatternStr *b,int *color_inf);

#endif